'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _yeomanGenerator = require('yeoman-generator');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

require('es6-promise').polyfill();
require('isomorphic-fetch');

function getPackageVersions(prop, packages) {
    var _this = this;

    var done = this.async();

    return Promise.all(packages.map(function (pkg) {
        return new Promise(function (resolve) {
            if (Array.isArray(pkg)) {
                var _pkg$slice = pkg.slice(0, 2);

                var _pkg$slice2 = _slicedToArray(_pkg$slice, 2);

                var name = _pkg$slice2[0];
                var version = _pkg$slice2[1];

                return resolve([name, '^' + version]);
            }

            fetch('//registry.npmjs.org/' + pkg + '/latest').then(function (res) {
                return res.json();
            }).then(function (ref) {
                return resolve([pkg, '^' + ref.version]);
            }).catch(function () {
                return resolve([pkg, '*']);
            });
        });
    })).then(function (deps) {
        _this.props[prop] = deps.reduce(function (memo, curr) {
            var _curr$slice = curr.slice(0, 2);

            var _curr$slice2 = _slicedToArray(_curr$slice, 2);

            var pkg = _curr$slice2[0];
            var version = _curr$slice2[1];

            if (pkg && version) {
                memo[pkg] = version;
            }

            return memo;
        }, {});

        done();
    }).catch(function () {
        _this.log('Something went wrong trying to install required modules. Try manually running `npm install` again.');
    });
}

function copy(src, dest) {
    var tpl = arguments.length <= 2 || arguments[2] === undefined ? true : arguments[2];

    if (tpl) {
        this.fs.copyTpl(this.templatePath(src), this.destinationPath(dest), this.props);
    } else {
        this.fs.copy(this.templatePath(src), this.destinationPath(dest));
    }
}

var AppGenerator = function (_Base) {
    _inherits(AppGenerator, _Base);

    function AppGenerator() {
        var _Object$getPrototypeO;

        _classCallCheck(this, AppGenerator);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        var _this2 = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(AppGenerator)).call.apply(_Object$getPrototypeO, [this].concat(args)));

        _this2.copy = copy.bind(_this2);
        _this2.getPackageVersions = getPackageVersions.bind(_this2);
        return _this2;
    }

    _createClass(AppGenerator, [{
        key: 'prompting',
        value: function prompting() {
            var _this3 = this;

            var done = this.async();

            var prompt = [{
                type: 'input',
                name: 'appName',
                message: 'What\'s the name of your application?'
            }, {
                type: 'input',
                name: 'port',
                message: 'Dev server port',
                default: 3000
            }, {
                type: 'list',
                name: 'installServer',
                message: 'Generate backend sample server for api?',
                choices: [{ name: 'Yes', value: true }, { name: 'No', value: false }],
                default: true
            }, {
                type: 'input',
                name: 'apiServerPort',
                message: 'Backend server port',
                when: function when(answers) {
                    return answers['installServer'];
                },
                default: 3008
            }, {
                type: 'list',
                name: 'install',
                message: 'Install dependencies?',
                choices: [{ name: 'Yes', value: true }, { name: 'No', value: false }],
                default: true
            }];

            this.prompt(prompt, function () {
                var props = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

                _this3.props = _extends({}, props, {
                    appNameSlug: _lodash2.default.kebabCase(props.appName).toLowerCase()
                });

                _this3.config.set(_this3.props);

                done();
            });
        }
    }, {
        key: 'writing',
        value: function writing() {
            this.copy('_package.json', 'package.json');
            this.copy('_gitignore', '.gitignore');
            this.copy('_gulpfile.babel.js', 'gulpfile.babel.js');
            this.copy('_babelrc', '.babelrc');
            this.copy('_webpack.development.js', 'webpack.development.js');
            this.copy('favicon.ico', 'favicon.ico', false);
            this.copy('README.md', 'README.md');
            this.copy('index.html', 'src/index.html');

            this.directory('js', 'src/js');
            this.directory('config', 'config');
            this.directory('styles', 'src/styles');

            if (this.props.installServer) {
                this.directory('server', 'server');
            }
        }
    }, {
        key: 'install',
        value: function install() {
            if (this.props.install) {
                this.installDependencies({ bower: false });
            }
        }
    }, {
        key: 'configuring',
        get: function get() {
            return {
                deps: function deps() {
                    this.getPackageVersions('deps', ["classnames", "es6-promise", "history", "immutable", "lodash", "material-design-icons", "normalize.css", "react", "react-addons-perf", "react-dom", "react-redux", "react-router", "react-tap-event-plugin", "redux", "redux-actions", "redux-devtools", "redux-logger", "redux-simple-router", "redux-thunk", "whatwg-fetch"].concat(this.props.installServer ? ['express'] : []));
                },
                devDeps: function devDeps() {
                    this.getPackageVersions('devDeps', ["autoprefixer-loader", "babel-loader", "babel-plugin-react-transform", "babel-polyfill", "babel-preset-es2015", "babel-preset-react", "babel-preset-stage-0", "css-loader", "extract-text-webpack-plugin", "file-loader", "gulp", "gulp-clean", "gulp-notify", "gulp-replace", "gulp-sequence", "gulp-util", "json-loader", "less", "less-loader", "react-transform-catch-errors", "react-transform-hmr", "redbox-react", "redux-devtools", "redux-devtools-dock-monitor", "redux-devtools-log-monitor", "style-loader", "svgo-loader", "url-loader", "webpack", "webpack-dev-server"].concat(this.props.installServer ? ['babel-cli'] : []));
                }
            };
        }
    }]);

    return AppGenerator;
}(_yeomanGenerator.Base);

module.exports = AppGenerator;