'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _yeomanGenerator = require('yeoman-generator');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function randomString(length) {
    var chars = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    var result = '';
    for (var i = length; i > 0; --i) {
        result += chars[Math.floor(Math.random() * chars.length)];
    }return result;
}

var EntityGenerator = function (_Base) {
    _inherits(EntityGenerator, _Base);

    function EntityGenerator() {
        var _Object$getPrototypeO;

        _classCallCheck(this, EntityGenerator);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        var _this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(EntityGenerator)).call.apply(_Object$getPrototypeO, [this].concat(args)));

        var port = _this.config.get('apiServerPort');

        _this.argument('name', {
            type: String,
            required: true,
            desc: 'Name of generated entity'
        });
        _this.argument('remotePath', {
            type: String,
            default: 'http://localhost:' + port + '/api/' + _lodash2.default.kebabCase(_this.name),
            desc: 'Remote api path to fetch entities from'
        });
        _this.option('with-no-api', {
            alias: 'n',
            desc: 'Disable generation of backend api handler for fetch requests'
        });

        _this.entityName = _this.name;
        _this.entityNameSnake = _lodash2.default.snakeCase(_this.name).toUpperCase();
        _this.entityNameKebab = _lodash2.default.kebabCase(_this.name);
        _this.entityNameCamel = _lodash2.default.camelCase(_this.name);
        return _this;
    }

    _createClass(EntityGenerator, [{
        key: 'writing',
        value: function writing() {
            var from = undefined,
                to = undefined,
                server = undefined,
                actions = undefined,
                reducer = undefined;

            from = this.templatePath('actions.js');
            to = this.destinationPath('src/js/actions/' + this.entityNameCamel + '.js');

            /** Generating actions for entity */
            this.fs.copyTpl(from, to, this);

            from = this.templatePath('reducer.js');
            to = this.destinationPath('src/js/reducers/' + this.entityNameCamel + '.js');

            /** Generating actions for entity */
            this.fs.copyTpl(from, to, this);

            actions = this.fs.read(this.destinationPath('src/js/actions.js'));
            actions = actions.replace('/** inject:action-import */', 'import ' + this.entityNameCamel + ' from \'./actions/' + this.entityNameCamel + '\';\n/** inject:action-import */');
            actions = actions.replace('/** inject:action */', this.entityNameCamel + ': ' + this.entityNameCamel + ',\n/** inject:action */');

            this.fs.write(this.destinationPath('src/js/actions.js'), actions);

            reducer = this.fs.read(this.destinationPath('src/js/reducer.js'));
            reducer = reducer.replace('/** inject:reducer-import */', 'import ' + this.entityNameCamel + 'Reducer from \'./reducers/' + this.entityNameCamel + '\';\n/** inject:reducer-import */');
            reducer = reducer.replace('/** inject:reducer */', this.entityNameCamel + ': ' + this.entityNameCamel + 'Reducer(state.get(\'' + this.entityNameCamel + '\'), action)\n\t\t/** inject:reducer */');

            this.fs.write(this.destinationPath('src/js/reducer.js'), reducer);

            /** Updating initial state */
            var jsonPath = this.destinationPath('config/state.json');

            var json = this.fs.readJSON(jsonPath) || {};

            json[this.entityNameCamel] = {
                isFetching: false,
                error: null,
                items: []
            };

            this.fs.writeJSON(jsonPath, json);

            if (this.config.get('installServer') && !this.options['with-no-api']) {
                var entities = _lodash2.default.range(0, 5).map(function (i) {
                    return { id: i, value: randomString(32) };
                });
                var varName = _lodash2.default.capitalize(this.entityNameCamel);

                server = this.fs.read(this.destinationPath('server/server.js'));
                server = server.replace('/** inject:route */', '/** ' + this.name + ' */\nlet entities' + varName + ' = require(\'./entity/' + this.entityNameKebab + '.json\');\napiRouter.get(\'/' + this.entityNameKebab + '\', (req, res) => res.json(entities' + varName + '));\napiRouter.put(\'/' + this.entityNameKebab + '\', (req, res) => {\n    const lastId = entities' + varName + '.length ? entities' + varName + '[entities' + varName + '.length - 1]["id"] : -1;\n    entities' + varName + '.push({id: lastId + 1, value: randomString(32)});\n    res.json(entities' + varName + ');\n});\napiRouter.delete(\'/' + this.entityNameKebab + '/:id\', (req, res) => {\n    entities' + varName + ' = entities' + varName + '.filter(item => item.id != req.params["id"]);\n    res.json(entities' + varName + ');\n});\n\n/** inject:route */');

                this.fs.write(this.destinationPath('server/server.js'), server);

                jsonPath = this.destinationPath('server/entity/' + this.entityNameKebab + '.json');

                /** Generating sample data for entity */
                this.fs.writeJSON(jsonPath, entities);
            }
        }
    }, {
        key: 'end',
        value: function end() {
            if (this.config.get('installServer') && !this.options['with-no-api']) {
                this.log();
                this.log('[WARN] Don\'t forget to reboot express server with "npm run server"');
                this.log();
            }
        }
    }]);

    return EntityGenerator;
}(_yeomanGenerator.Base);

module.exports = EntityGenerator;