'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _yeomanGenerator = require('yeoman-generator');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var routeIcon = 'help_outline';

var RouterGenerator = function (_Base) {
    _inherits(RouterGenerator, _Base);

    function RouterGenerator() {
        var _Object$getPrototypeO;

        _classCallCheck(this, RouterGenerator);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        var _this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(RouterGenerator)).call.apply(_Object$getPrototypeO, [this].concat(args)));

        _this.argument('routeName', {
            type: String,
            required: true,
            desc: 'The name of generated route. Used for menu label and route path'
        });

        _this.option('parent', {
            alias: 'p',
            type: String,
            default: null,
            desc: 'The name of parent route, that generated one will be nested in'
        });

        _this.option('with-no-entity', {
            alias: 'e',
            type: Boolean,
            default: false,
            desc: 'Disable generation of entity and api handlers'
        });

        _this.routePath = _lodash2.default.kebabCase(_this.routeName);
        _this.routeLabel = _lodash2.default.capitalize(_this.routeName);

        _this.pageClassName = _lodash2.default.capitalize(_lodash2.default.camelCase(_this.routeName));
        _this.pagePathName = _this.pageClassName;
        _this.entityName = _lodash2.default.camelCase(_this.routeName);
        return _this;
    }

    _createClass(RouterGenerator, [{
        key: 'writing',
        value: function writing() {
            /** Updating routes */
            var jsonPath = this.destinationPath('config/routes.json');

            var json = this.fs.readJSON(jsonPath) || {};

            var pageClassPath = undefined;
            var parentRoute = this.options.parent;

            if (parentRoute && !json[parentRoute]) {
                throw Error('Parent node "' + parentRoute + '" was not configured!');
            }

            if (!parentRoute) {
                /** Add top-level route */
                json = _lodash2.default.extend(this.fs.readJSON(jsonPath) || {}, _defineProperty({}, this.routeName, {
                    "path": this.routePath,
                    "label": this.routeLabel,
                    "icon": routeIcon
                }));

                pageClassPath = this.pageClassName;
            } else {
                /** Add sub-route for specified parent */
                json[parentRoute]['routes'] = _lodash2.default.extend(json[parentRoute]['routes'] || {}, _defineProperty({}, this.routeName, {
                    "path": this.routePath,
                    "label": this.routeLabel,
                    "icon": routeIcon
                }));

                this.pagePathName = _path2.default.join(_lodash2.default.capitalize(_lodash2.default.camelCase(parentRoute)), this.pageClassName);
                pageClassPath = this.pagePathName;
            }

            this.fs.writeJSON(jsonPath, json);

            if (!this.options['with-no-entity']) {

                /** Generating Page component */
                this.fs.copyTpl(this.templatePath('PageDispatched.jsx'), this.destinationPath('src/js/components/pages/' + pageClassPath + '.jsx'), this);

                this.composeWith('react-redux-app:entity', { args: [this.routeLabel] });
            } else {
                /** Generating Page component */
                this.fs.copyTpl(this.templatePath('Page.jsx'), this.destinationPath('src/js/components/pages/' + pageClassPath + '.jsx'), this);
            }
        }
    }]);

    return RouterGenerator;
}(_yeomanGenerator.Base);

module.exports = RouterGenerator;